var ceneo_branza = null;
var ceneo_branze = new Object();
var branza_old   = -1;
var o_ceneo_ajax = createXmlHttpRequestObject();
var s_form_name = 'ceneo_form';
var parametry = new Object();
var ceneo_atrybuty = null;
var ceneo_cenniki = null;

var o_atrybuty_div = null;

function ceneo_branza_init( ceneo_branza ){

    if( typeof(ceneo_branza) == 'object' && typeof(ceneo_branza.branza) != 'undefined' ){
        
        ceneo_branze[ceneo_branza.branza] = ceneo_branza;
        
        ceneo_wyswietl_atrybuty( ceneo_branza );

    }else{
        branza_old = 0;

        server_connect(o_ceneo_ajax, ADMIN_URL + '?action='+action+'&mode='+MODE_AJAX+'&branza=0', ceneo_branza_response );
    }
}

function ceneo_branza_onchange( o_sel ){

    var o_form = o_sel.form;
    var branza = o_sel.value;

    if( branza != '' ){
        if( branza_old != -1 && ceneo_branze[branza_old] ){
            ceneo_branze[branza_old].powiazania = new Object();

            for( var a in ceneo_branze[branza_old].atrybuty ){
                ceneo_branze[branza].powiazania[a] = o_form.elements['ATRYBUTY['+a+']'].value;
            }
        }
        
        branza_old = branza;
        
        if( typeof(ceneo_branze[branza]) != 'object' ){
            server_connect(o_ceneo_ajax, ADMIN_URL + '?action='+action+'&mode='+MODE_AJAX+'&branza=' + branza, ceneo_branza_response );
        }else{
            ceneo_wyswietl_atrybuty( ceneo_branze[branza] );
        }
        
    }
}

function ceneo_branza_response( o_xml, o_txt ){

    if( arguments.length < 2 ){
        alert('Bdna odpowied serwera.');
        return false;
    }

    var o_atrybuty_xml = o_xml.getElementsByTagName('atrybut');
    
    var branza = document.forms[s_form_name].elements['BRANZA'].value;
    

    var o_atrybut_xml = null;
    var o_atrybuty = new Object();

/* pobieramy nowe nazwy funkcji z pliku XML w postaci tablicy */
    var key, val;
    var i;

    for( i = 0; i < o_atrybuty_xml.length; i++){
        o_atrybut_xml = o_atrybuty_xml.item(i);
        
        key = o_atrybut_xml.getElementsByTagName('nazwa').item(0).firstChild.data;
        val = o_atrybut_xml.getElementsByTagName('label').item(0).firstChild.data;

        o_atrybuty[key] = val;
    }

    ceneo_branze[branza] = {
        'branza' : branza,
        'atrybuty' : o_atrybuty,
        'powiazania' : new Object(),
    }
    
    ceneo_wyswietl_atrybuty( ceneo_branze[branza] );
}


function ceneo_wyswietl_atrybuty( ceneo_branza ){
    var branza = ceneo_branza.branza;

    if( !o_atrybuty_div ){
        o_atrybuty_div = document.getElementById('ceneo_atrybuty');
    }

    var a = null;
    var label, rowclass, al, pl, ll, ppl, selected, html = '';
    var i = 0;
    
    for( a in ceneo_branza.atrybuty ){
        label = ceneo_branza.atrybuty[a];
        
        rowclass  =( i++ % 2) ? 'rowodd' : 'roweven';
        
        html += '<div class="'+rowclass+'">';
        html += '<div class=datalabel><label for="CENEO_ATRYBUT_'+a+'">' + label + ':</label></div>';
        
        select_options = '<option value="">Wybierz</option>';
        if( ceneo_branza.powiazania[a] ){
            for( p in parametry ){
                select_options += '<option value="'+p+'" '+(( ceneo_branza.powiazania[a] == p ) ? 'selected' : '')+'>'+parametry[p]+'</option>';
            }
        }else{
            al = a.toLowerCase();
            ll = label.toLowerCase();
            
            for( p in parametry ){
                selected = false;
                
                pl = p.toLowerCase();
                ppl = parametry[p].toLowerCase();
                
                if( (pl == al) || (ppl == ll ) || (pl.indexOf(al) >= 0) || (ppl.indexOf(al) >= 0) || (ppl.indexOf(ll) >= 0) ){
                    selected = true;
                }
                select_options += '<option value="'+p+'" '+(( selected ) ? 'selected' : '')+'>'+parametry[p]+'</option>';
            }
        }
        
        html += '<div class=datavalue>';
        html += '<select name="ATRYBUTY['+a+']" id="CENEO_ATRYBUT_'+a+'">'+select_options+'</select>';
        html += '</div>';
        html += '<div class=rowend></div>';
        html += '</div>';
    }
    
    o_atrybuty_div.innerHTML = html;
}

function cmp_atr( a, b ){
    a = trim(a.toLowerCase());
    b = trim(b.toLowerCase());
    
    if( a == b ){
        return true;
    }

    //a.replace(/ʶ/);
}

var o_ceneo_cache_period_row = null;
function ceneo_cahce_onclick(o_check ){
    if(!o_ceneo_cache_period_row){
        o_ceneo_cache_period_row = document.getElementById('ceneo_cache_period_row');
    }

    if( o_check.checked ){
        show_obj(o_ceneo_cache_period_row);
    }else{
        hide_obj(o_ceneo_cache_period_row);
    }
}


var o_ceneo_cenniki_row = null;
var o_ceneo_grupa_row = null;
function ceneo_oferta_onchange( o_sel ){
    if(! o_ceneo_cenniki_row ){
        o_ceneo_cenniki_row = document.getElementById('ceneo_cenniki_row');
        o_ceneo_grupa_row = document.getElementById('ceneo_grupa_row');
    }
    
    if( o_sel.value == 1 ){
        show_obj(o_ceneo_cenniki_row);
        hide_obj(o_ceneo_grupa_row);
    }else if( o_sel.value == 2 ){
        show_obj(o_ceneo_grupa_row);
        hide_obj(o_ceneo_cenniki_row);
    }else{
        hide_obj(o_ceneo_grupa_row);
        hide_obj(o_ceneo_cenniki_row);

    }
}

function ceneo_update_grupa_nazwa( grupa_id, grupa_nazwa ){
    
    if( !document.forms[s_form_name] ){
        alert('Bd! W dokumencie nie ma formularza o nazwie: '+ s_form_name);
    }else{
        document.forms[s_form_name].elements['GRUPA_ID'].value = grupa_id;
        document.forms[s_form_name].elements['GRUPA_NAZWA'].value = grupa_nazwa;
    }
}


function ceneo_cenniki_onreturn(){
    cenniki_load( 'ceneo', ceneo_cenniki_print );
}


function ceneo_cenniki_assign( cenniki ){
    ceneo_cenniki = cenniki;
}


var o_ceneo_cenniki_div = null;
function ceneo_cenniki_print( cenniki ){

    if( !o_ceneo_cenniki_div ){
        o_ceneo_cenniki_div = document.getElementById('ceneo_cenniki_div');
    }

    ceneo_cenniki = cenniki;

    cenniki_print(ceneo_cenniki, o_ceneo_cenniki_div );
}

function ceneo_cennik_delete( num ){
    
    cennik_delete('ceneo', ceneo_cenniki[num].ID);
    
    ceneo_cenniki.splice(num, 1);
    
    cenniki_print(ceneo_cenniki, o_ceneo_cenniki_div );
}

cennik_ondelete = ceneo_cennik_delete;