var ACTION_TOWARY = 0;
o_towary_ajax = createXmlHttpRequestObject();

function TowaryMulti( settings ){
    this.multi = settings.prefix;

    this.o_ajax = createXmlHttpRequestObject();
    
    if( settings.div_id){
        this.o_div = document.getElementById( settings.div_id );
    }else{
        this.o_div = document.getElementById( this.multi + '_towary_div');
    }
    
    if( settings.var_name ){
        this.var_name = settings.var_name;
    }else{
        this.var_name = 'o_' + this.multi + '_towary';
    }

    this.o_table = null;

    if( settings.items ){
        this.a_items = settings.items;
    }else{
        this.a_items = new Array();
    }
    this.n_item = -1;

    if( settings['form_name'] ) {
        this.o_form = document.forms[settings.form_name];
        this.towar_id_field = settings.towar_id_field;
        this.towar_nazwa_field = settings.towar_nazwa_field;
    }else{
        this.o_form = null;
        this.towar_id_field = '';
        this.towar_nazwa_field = '';
    }


    this.init    = towary_init;
    this.print   = towary_print;
    this.make_tr = towary_make_tr;

    this.wybierz  = towary_wybierz;

    this.load     = towary_load;
    this.load_response = towary_load_response;

    this.usun   = towar_usun;
    this.usun_response   = towar_usun_response;

    this.dodaj          = towar_dodaj;
    this.dodaj_response = towar_dodaj_response;

    this.init();
}

function towary_init(){
    this.o_table = document.createElement('TABLE');
    this.o_table.id = this.multi + '_towary_grid';
    this.o_table.className = 'grid';
    this.o_table.style.width = '100%';
    this.o_table.cellPadding = 2;
    this.o_table.cellSpacing = 0;

    o_tbody = document.createElement('TBODY');

    o_tr = document.createElement('TR');
    var o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('#')) ;
    o_td.width = '20px';
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Indeks'));
    o_td.width = '100px';
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Nazwa')) ;
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Indeks 2'));
    o_td.width = '100px';
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Producent'));
    o_td.width = '100px';
    o_tr.appendChild(o_td);


    o_tbody.appendChild(o_tr);

    this.o_table.appendChild(o_tbody);
    this.o_div.appendChild( this.o_table );
    
    this.load();
}

function towary_wybierz( search ){
    var url = ADMIN_URL + '?action=' + ACTION_TOWARY + '&multi=' + this.multi + (( search && search != '' ) ? '&search=' + search : '');

    server_connect( this.o_ajax, ADMIN_URL + '?action=' + ACTION_TOWARY + '&mode=' + MODE_AJAX + '&multi=' + this.multi + '&init=1' );

    otworz_okno( url, this.multi + 'towary');
}

function towar_usun( num, o_tr ){
    var o_self = this;

    if( num <  0 || num >= this.a_items.length ){
        alert('Kliknij najpierw na towar, a nastepnie wcinij klawisz delete.');
        return;
    }

    if( confirm('Jeste pewien, e chcesz usun towar ' + this.a_items[num].NAZWA + '?' ) ){
        this.n_item = num; this.o_tr = o_tr;

        var towar_id = this.a_items[num].ID;

        server_connect( this.o_ajax, ADMIN_URL + '?action=' + ACTION_TOWARY + '&mode=' + MODE_AJAX + '&towar_id=' + towar_id + '&multi=' + this.multi + '&check=0', function () { o_self.usun_response( arguments ); } );
    }
}

function towar_usun_response( args ){
    var o_self = this;
    
    var o_txt = args[0];

    if( o_txt == 'OK' ){

        var o_item = this.a_items.splice(this.n_item, 1);

        if( this.n_item >= this.a_items.length ){
            var o_tr = this.o_tr.previousSibling;

            this.n_item = this.a_items.length - 1;

            this.o_tr.parentNode.removeChild( this.o_tr );

            if( this.n_item >= 0 ){
                podswietl_wiersz( o_tr );
            }else{
                this.o_div.style.display = 'none';
            }

            grid_row--;
        }else{
            var o_tr = this.o_tr.nextSibling;

            this.o_tr.parentNode.removeChild( this.o_tr );

            var o_td, i  = this.n_item;

            var o_tr1 = o_tr;

            while( o_tr ){
                //console.log(o_tr.nodeName);

                if( o_tr.nodeName == 'TR' ){
                    o_td = o_tr.firstChild;
                    o_td.innerHTML = (i+1) + '. ';
                    o_tr.className = 'wiersz' + ( (i%2) + 1 );
                    o_tr.onclick = function(){
                        podswietl_wiersz( this );
                    };

                    i++;
                }

                o_tr = o_tr.nextSibling;
            }

            podswietl_wiersz( o_tr1 );
        }

        if( this.o_form ){
            var o_input  = document.createElement('INPUT');
            o_input.type  = 'hidden';
            o_input.name  = 'towary2delete[]';
            o_input.value = o_item['ID'];

            this.o_form.appendChild( o_input );
        }
    }else{
        alert('Nie udao si usun towaru: ' + this.a_items[this.a_item].NAZWA );
    }
}

function towar_dodaj( towar_id, towar_nazwa ){
    var o_self = this;
    var i, znaleziono = false;

    if( arguments.length == 0 ){
        towar_id   = this.o_form.elements[this.towar_id_field].value;
        towar_nazwa = this.o_form.elements[this.towar_nazwa_field].value;
    }

    if( towar_id > 0 ){
        var url = ADMIN_URL + '?action=' + ACTION_TOWARY + '&mode=' + MODE_AJAX + '&towar_id=' + towar_id + '&multi=' + this.multi + '&check=1&info=1';

        for( i = 0 ; i < this.a_items.length; i++ ){
            if( this.a_items[i].ID == towar_id ){
                znaleziono = true;
                break;
            }
        }

        if( znaleziono ){
            alert('Kontrahent '+ towar_nazwa + ' zosta ju dodany.' );
        }else{
            server_connect( this.o_ajax, url, function () { o_self.dodaj_response( arguments ); } );

            if( this.o_form )
                this.o_form.elements[this.towar_id_field].value  = this.o_form.elements[this.towar_nazwa_field].value  = '';

        }
    }else{
        alert('Wybierz towar.');
    }
}

function towar_dodaj_response( args ){
    if( args.length < 2 ){
        alert('Bdna odpowied serwera. Sprbuj ponownie wybra towarw.');
        return false;
    }
    var o_self = this;
    
    var o_xml = args[0];

    var o_towar_xml  = o_xml.getElementsByTagName('towar').item(0);
    var atrybut, o_towar      = new Object();

    for( j = 0; j < o_towar_xml.attributes.length; j++){
        atrybut = o_towar_xml.attributes.item(j);
        o_towar[atrybut.name] = atrybut.value;
    }

    this.a_items.push( o_towar );

    var i = this.a_items.length - 1;
    
    var o_tr = document.createElement('TR');
    this.make_tr( o_tr, i);
    o_tr.onclick = function(){
        o_self.n_item = i;
        podswietl_wiersz( this );
    }
    this.o_table.firstChild.appendChild( o_tr );

    if( this.o_div.clientHeight == 0  ){
        this.o_div.style.display = 'block';
    }
}

function towary_load(){
    var o_self = this;

    server_connect( this.o_ajax, ADMIN_URL + '?action=' + ACTION_TOWARY + '&mode='+ MODE_AJAX + '&load=' + this.multi, function () { o_self.load_response( arguments ); } );
}

function towary_load_response( args ){
    if( args.length < 2 ){
        alert('Bdna odpowied serwera. Sprbuj ponownie wybra towarw.');
        return false;
    }
    var o_xml = args[0];

    var o_towary_xml = o_xml.getElementsByTagName('towar');
    var o_towar_xml  = new Object();
    var o_towar      = new Object();

    //zeruje alarmy
    this.a_items = new Array();

    /* pobieramy nowe nazwy funkcji z pliku XML w postaci tablicy */
    var atrybut, key, value, i, j;

    for( i = 0; i < o_towary_xml.length; i++){
        o_towar_xml = o_towary_xml.item(i);

        o_towar = new Object();

        for( j = 0; j < o_towar_xml.attributes.length; j++){
            atrybut = o_towar_xml.attributes.item(j);
            o_towar[atrybut.name] = atrybut.value;
        }

        this.a_items.push( o_towar );
    }

    if( o_towary_xml.length > 0 )
        this.print();
}


function towary_make_tr( o_tr, i ){
    o_towar = this.a_items[i];

    var o_td = document.createElement('TD');
    
    o_td.appendChild(  document.createTextNode(( i + 1 )+ '.'));
    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.appendChild(  document.createTextNode(o_towar.SKROT));
    var o_input =  document.createElement('input');
    o_input.type='hidden';
    o_input.name='towary[]';
    o_input.value= o_towar.ID;
    o_td.appendChild(  o_input );
    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.appendChild(  document.createTextNode(o_towar.NAZWA));
    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.appendChild(  document.createTextNode(o_towar.SKROT2));
    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.appendChild(  document.createTextNode(o_towar.PRODUCENT_NAZWA));
    o_tr.appendChild(o_td);

}


function towary_print(){
    var i, o_tbody, o_tr, o_tr_highlight;

    var o_self = this;

    o_tbody = this.o_table.firstChild;

    for( i = 0; i < this.a_items.length; i++ ){

        if( o_tbody.childNodes[i+1] ){
            o_tr = o_tbody.childNodes[i+1];

            while ( o_tr.childNodes.length >= 1 ){
                o_tr.removeChild( o_tr.firstChild );
            }
            
            this.make_tr( o_tr, i );
        }else{
            o_tr = document.createElement('TR');

            this.make_tr( o_tr, i );
            
            o_tbody.appendChild( o_tr );
        }

        var num = i;
        
        o_tr.onclick = function(){
            o_self.n_item = num;
            podswietl_wiersz( this );
        }
        
        o_tr.className = 'wiersz' +(i%2+1);

        if( i == this.n_item ){
            o_tr_highlight = o_tr;
            o_tr.className += ' highlight';
        }
    }

    podswietl_wiersz( o_tr_highlight );

    grid_setup( this.multi + '_towary_grid', {  'ondelete' : function(){ o_self.usun(arguments[0], arguments[1]) }, } );
}



/**************************************************************************************************/
function towary_checkbox_onclick( o_check ){
    var url = ADMIN_URL + '?action=' + ACTION_TOWARY + '&mode=' + MODE_AJAX + '&towar_id=' + o_check.value + '&multi=' + multi;

    url += '&check=' + (( o_check.checked ) ? '1' : '0' );

    server_connect( o_towary_ajax, url );
}

function towary_onreturn(){
    if( arguments.length == 0 ){
        onreturn = multi + '_towary_onreturn';
    }else{
        onreturn = arguments[0] + '_towary_onreturn';
    }


    if( opener.closed ){
        alert('Okno docelowe zostao zamknite i nie mona zwrci danych dla okna macierzystego!');
        window.close();
        return;
    }
    if( typeof(opener[onreturn]) != 'function' ){
        alert('W oknie docelowym nie zostaa znaleziona funkcja: ' + onreturn + '. By moe okno macierzyste zostao przeadowane lub zmieniono lokalizacj.' );
        opener.focus();
        window.close();
        return;
    }

    try{
        opener[onreturn]();
    }catch(o_error){
        alert('Nie mona byo zwri zmiany. Wystapi nastepujcy bd: \n' + o_error.toString() );
    }

    opener.focus();
    window.close();
}

function towary_select_anuluj(){
    opener.focus();window.close();
}

function towary_anuluj(){
    var typ = ( arguments.length == 0 ) ? multi  : arguments[0] ;

    server_connect( o_towary_ajax, ADMIN_URL + '?action=' + ACTION_TOWARY + '&mode=' + MODE_AJAX + '&multi=' + typ + '&anuluj=1' );

    opener.focus();
    window.close();
}

function towary_onescape(){
    if( confirm('Jeste pewien e chcesz zamkn okno wyboru towarw i powrci do poprzedniego okna.') ){
        towary_anuluj();
    }
}

function towary_onenter( num, o_tr ){
    towary_onreturn();
}

function towary_onspace( num, o_tr ){
    var o_inputs = o_tr.getElementsByTagName('INPUT');
    var o_input, i;

    o_input = o_inputs.item(0);

    if( o_input ){
        o_input.checked = !o_input.checked;

        towary_checkbox_onclick( o_input );
    }
}

function towary_onleft( num, o_tr ){

    var strona, url = location.href;
    strona_match = url.match(/strona=([0-9]+)/);
    if( strona_match ){
        strona = parseInt(strona_match[1]);
        strona = isNaN(strona) ? 0 : strona;

        if( strona > 1 ){
            window.location = url.replace("strona=" + strona, "strona=" + (strona-1) );
            return;
        }
    }

    alert('Nie moesz przej na wczeniejsz podstron.');
}

function towary_onright( num, o_tr ){
    var strona, url = location.href;
    strona_match = url.match(/strona=([0-9]+)/);

    if( strona_match ){
        strona = parseInt(strona_match[1]);
        strona = isNaN(strona) ? 0 : strona;

        if( strona < liczba_stron ){
             url = url.replace("strona=" + strona, "strona=" + (strona+1) );
        }else{
            alert('Nie moesz przej na nastpn podstron poniewa jeste na ostatniej stronie.');
            return;
        }
    }else{
        url += '&strona=2';
    }

    window.location = url;
}

