// JavaScript Document
var o_synonimy_ajax = createXmlHttpRequestObject();

var synonimy = [];
var synonim_num = -1;

var o_synonim_form_div = null;
var o_synonimy_div     = null;

/******************************************************************************/

function show_synonim_form( action, num, show_to_all ){

    if( action == 'edit' ){
        if( arguments.length == 1 ){
            if( synonim_num  < 0 ){
                alert('Kliknij dwa razy na synonim aby go edytowa lub kliknij raz na synonim, a nastpnie wcinij przycisk edycja.');
                return;
            }else{
                num = synonim_num;
            }
        }
    }else{
        if(arguments.length < 2 ){
            num = synonimy.length;
        }
    }


    try{
      showTlo();
    }catch(e){

    }

/******************************************************************************/

    var f = document.forms['synonim_form'];

    f.onsubmit = function(){
        synonim_add_edit();
        return false;
    }

    f.elements['num'].value = num;


    if( typeof(synonimy[num]) == 'object' ){
        f.elements['ID'].value = synonimy[num].ID;
        f.elements['SYNONIM'].value = synonimy[num].SYNONIM;
    }

    if( !o_synonim_form_div ){
        o_synonim_form_div = document.getElementById('synonim_form_div');
    }

    center_both_obj( o_synonim_form_div );

    f.elements['SYNONIM'].focus();
/******************************************************************************/

}

function synonim_anuluj(){
    var f = document.forms['synonim_form'];

    f.elements['ID'].value = '';
    f.elements['num'].value = '';
    f.elements['SYNONIM'].value = '';

    hide_obj(o_synonim_form_div );
    
    try{
      hideTlo();
    }catch(e){}
}

function synonim_add_edit( f ){
    if( arguments.length == 0 || !f || !f.name ){
        f = document.forms['synonim_form'];
    }
    var ID = parseInt(f.elements['ID'].value );
    ID = isNaN(ID)?0:ID;

    var num = parseInt(f.elements['num'].value );
    if( isNaN(num) || num < 0 || num > synonimy.length ){
        num = 0;
    }
    
    var SYNONIM = trim(f.elements['SYNONIM'].value);

    var index = in_synonimy( SYNONIM )
    if( index && index != num ){
        alert('Podany przez ciebie synonim: ' + SYNONIM + ' jest ju zdefiniowany dla tego wyrazu!');
        return false;
    }
    
    synonimy[num] = {
        'ID'   : ID,
        'SYNONIM' : SYNONIM,
        'zmieniony'   : 1
    };

    
    synonimy_print();

    synonim_anuluj();
}

function synonimy_print(){
    //if( synonimy.length == 0) return;

    var i = 0;

    var str = '';
    str = '<table width=100% align="center" cellpadding=2 cellspacing=0 class="grid" id="synonimy_tab_grid">';
    str += '<tr>';
    str += '  <th align=center width=100>#</th>';
    str += '  <th align=center >Synonim</th>';
    str += '</tr>';

    var img = '';

    for( i= 0; i < synonimy.length; i++ ){
        str += '<tr onclick="podswietl_wiersz(this); synonim_num = ' + i + '; " ondblclick="show_synonim_form( \'edit\', ' + i + ');" class="wiersz' + ( (i%2) + 1 ) + ((synonim_num == i)?' highlight':'')+'">';
        str += '    <td align=center width=100>' +( i + 1 )+ '. <input type="hidden" name="synonimy['+i+'][zmieniony]" value="' + htmlspecialchars(synonimy[i]['zmieniony']) + '" ></td>';
        str += '    <td >' + synonimy[i]['SYNONIM'] + '<input type="hidden" name="synonimy['+i+'][ID]" value="' + synonimy[i]['ID'] + '" > <input type="hidden" name="synonimy['+i+'][SYNONIM]" value="' + synonimy[i]['SYNONIM'] + '" > </td>';
        str += '</tr>';
    }
    str += '</table>\n';

    if( !o_synonimy_div ){
        o_synonimy_div = document.getElementById('synonimy_div');
    }

    o_synonimy_div.innerHTML = str;

    if( synonim_num >= 0){
        //to do podwietlania
        var rows = o_synonimy_div.getElementsByTagName('TR');
        //zaznaczam wiersz zeby potem mc go zgasi
        old_row = rows[synonim_num + 1];
    }
}

function synonim_delete( num ){
    if( arguments.length == 0 ){
        num = synonim_num;
        synonim_num = -1;
        if( num <  0){
            alert('Kliknij najpierw na synonim, a nastepnie wcinij przycisk usu.');
            return;
        }
    }
    synonimy.splice(num, 1);

    synonimy_print();
}



function in_synonimy( str ){
    str = str.toLowerCase();
    for( i = 0; i < synonimy.length; i++ ){
        if( synonimy[i].SYNONIM.toLowerCase() == str ){
            return i;
        }
    }

    return false;
}
/******************************************************************************/


