

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_CONTACT_GRUPY (
    CONTACT_ID  ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    GRUPA_ID    ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    EXT         BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */
);




/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_CONTACT_GRUPY_CONTACT_ID ON WWW_CONTACT_GRUPY (CONTACT_ID);
CREATE INDEX WWW_CONTACT_GRUPY_GRUPA_ID_EXT ON WWW_CONTACT_GRUPY (GRUPA_ID, EXT);


/* Fields descriptions */

DESCRIBE FIELD CONTACT_ID TABLE WWW_CONTACT_GRUPY
'Wzór typu dla pól zawieraj?cych identyfikator rekordu (musi zawiera? warto??)';

DESCRIBE FIELD GRUPA_ID TABLE WWW_CONTACT_GRUPY
'Wzór typu dla pól zawieraj?cych identyfikator rekordu (musi zawiera? warto??)';

DESCRIBE FIELD EXT TABLE WWW_CONTACT_GRUPY
'Wzór typu dla pól zawieraj?cych warto?? logiczn?: tak lub nie';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_CONTACT_GRUPY TO WWW_ROLE ;
