<div id="siodemkaPrzesylkaDialog" style="display: none;">
<form action="{$ADMIN_URL}" method="POST" name="siodemkaPrzesylkaForm">
<input type="hidden" name="action" value="{$action}" />
<input type="hidden" name="mode" value="" />
{if $mode == 'sp' || $mode == 'fs' || $mode == 'pa'}
    <input type="hidden" name="doc_type" value="sp" />
{else}
    <input type="hidden" name="doc_type" value="zk" />
{/if}

<div class="data">

<table width="100%" cellspacing="0" cellpadding="0" border="0">
<tr>
    <td width="150" >
        <img src="{$TPL_IMG_URL}/siodemka_logo.gif" alt="Sidemka S.A." />
    </td>

    <td valign=top>
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaNumer">Numer przesyki:</label></div>
            <div class=datavalue>
                <a class="help" title="Numer listu przewozowego nadawany po stworzeniu przesyki w systemie WebMobile7"></a>
                <input type="text" class="text" name="nrPrzesylki" id="siodemkaPrzesylkaNumer" value="0000000000000" title="0000000000000" maxlength="100" readonly="readonly" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaStacjaNadania">Stacja nadania:</label></div>
            <div class=datavalue><input type="text" class="text" size="5" name="nad" id="siodemkaPrzesylkaStacjaNadania" value="XXX"  title="XXX" maxlength="3" readonly="readonly" /></div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaStacjaOdbioru">Stacja odbioru:</label></div>
            <div class=datavalue><input type="text" class="text" size="5" name="odb" id="siodemkaPrzesylkaStacjaOdbioru" value="XXX" title="XXX" maxlength="3" readonly="readonly" /></div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaNumerExt">Numer zewntrzny:</label></div>
            <div class=datavalue>
                <a class="help" rel="#siodemkaPrzesylkaNumerExtHint"></a>

                <input type="text" class="text" name="nrExt" id="siodemkaPrzesylkaNumerExt" value="" maxlength="30" />
{literal}
                <div class="hint" id="siodemkaPrzesylkaNumerExtHint">
                    Numer zewntrzny np. numer zamwienia lub numer dokumentu sprzeday wystawionego do zamwienia.
                    Pole do dyspozycji klienta, aby atwiej ledzi przesyki w systemie WebMobile7 (max. 30 znakw alfanumerycznych).
                    Mona tutaj wykorzysta zmienne, aby przenie dane z zamwienia lub dokumentu sprzeday wystawionego dla zamwienia: <br />
                        {$DOC_NUMER} - aby wstawi w to pole numer dokumentu dla ktrego jest generowana przesyka<br />
                        {$ZK_NUMER} - aby wstawi w to pole numer zamwienia<br />
                        {$SP_NUMER} - taki cig znakw zostanie zastpiony numerem paragonu lub faktury wystawionego do zamwienia
                </div>
{/literal}
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaMpk">MPK:</label></div>
            <div class=datavalue>
                <a class="help" title="Miejsce powstawania kosztw. Pole do dyspozycji klienta do wykorzystania w ramach rozlicze midzydziaowych (max. 10 znakw alfanumerycznych)"></a>
                <input type="text" class="text alphanumeric" name="mpk" id="siodemkaPrzesylkaMpk" value="" maxlength="10"  />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaSzablon">Szablon:</label></div>
            <div class=datavalue>
                <a class="help" title="Nazwa szablonu ktry ma zosta wykorzystany do wygenerowania przesyek"></a>

                <input type="text" class="text alphanumeric multi0" name="template" id="siodemkaPrzesylkaTemplate" value="" maxlength="16"  />

                <select name="szablon" id="siodemkaPrzesylkaSzablon">
                    <option value="">Wybierz</option>
                </select>
            </div>
        </div>
    </td>
</tr>
</table>

{**************************************************************************************************}
<table width="100%" cellspacing="0" cellpadding="0" border="0" class="template" style="display: none;" id="siodemkaPrzesylkaDokumentTemplate">
<tr>
    <td width="50%" valign=top>
        <div class="even padding0">
            <div class=datalabel>Numer dokumentu:</div>
            <div class=datavalue>%NUMER%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Data wystawienia:</div>
            <div class=datavalue>%DATA_WYSTAWIENIA%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Sposb patnoci:</div>
            <div class=datavalue>%NAZWA_SPOSOBU_PLATNOSCI%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Sposb dostawy</div>
            <div class=datavalue>%NAZWA_SP_DOSTAWY%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Warto netto</div>
            <div class=datavalue>%PLN_WARTOSC_NETTO%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Warto brutto</div>
            <div class=datavalue>%PLN_WARTOSC_BRUTTO%&nbsp;</div>
        </div>
    </td>

    <td width="50%" valign=top>
        <div class="even padding0">
            <div class=datalabel>Nazwa odbiorcy:</div>
            <div class=datavalue>%NAZWA_SKROCONA_ODBIORCY%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Kod i miejscowo:</div>
            <div class=datavalue>%adres.kod% %adres.miasto%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Adres:</div>
            <div class=datavalue>%adres.ulica% %adres.nrDom% %adres.nrLokal%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>E-mail</div>
            <div class=datavalue>%EMAIL%&nbsp;</div>
        </div>

        <div class="even padding0">
            <div class=datalabel>Telefon</div>
            <div class=datavalue>%TEL%&nbsp;</div>
        </div>

    </td>
</table>

<div id="siodemkaPrzesylkaDokument" style="display: none;"></div>

{**************************************************************************************************}

<table width="100%" cellspacing="0" cellpadding="0" border="0">
<tr class="head">
    <td width="50%">Nadawca</td>
    <td width="50%">Odbiorca</td>
</tr>

<tr>
    <td width="50%" valign=top>
        <div class="even padding0" >
            <div class=datalabel><label for="siodemkaPrzesylkaNadawcaNumer">Numer nadawcy:</label></div>
            <div class=datavalue>
                <input type="text" class="text" name="nadawca[numer]" id="siodemkaPrzesylkaNadawcaNumer" value="" maxlength="10"/>
                <a href="{$ADMIN_URL}?action={$action}&mode=kontrahent&search=true" class="search-btn czyNadawca" id="siodemkaNadawcaSzukaj" title="Szukaj nadawc">Szukaj</a>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaNadawcaNazwisko">Nazwisko:</label></div>
            <div class=datavalue>
                <a class="help" title="Nazwisko osoby nadajcej przesyk (max. 100 znakw)"></a>
                <input type="text" class="text" name="nadawca[nazwisko]" id="siodemkaPrzesylkaNadawcaNazwisko" value="" maxlength="100" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaNadawcaImie">Imi:</label></div>
            <div class=datavalue>
                <a class="help" title="Imi osoby nadajcej przesyk (max. 50 znakw)"></a>
                <input type="text" class="text" name="nadawca[imie]" id="siodemkaPrzesylkaNadawcaImie" value="" maxlength="50"/>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaNadawcaTelefon">Telefon:</label></div>
            <div class=datavalue>
                <a class="help" title="telefon kontaktowy osoby nadajcej przesyk (max. 50 znakw)"></a>
                <input type="text" class="text" name="nadawca[telKontakt]" id="siodemkaPrzesylkaNadawcaTelefon" value="" maxlength="50"/>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaNadawcaEmail">E-mail:</label></div>
            <div class=datavalue>
                <a class="help" title="E-mail osoby nadajcej przesyk (max. 80 znakw)"></a>
                <input type="text" class="text" name="nadawca[emailKontakt]" id="siodemkaPrzesylkaNadawcaEmail" value="" maxlength="80"/>
            </div>
        </div>

        <div class="head">Patnik</div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPlatnikNumer">Numer platnika:</label></div>
            <div class=datavalue>
                <a class="help" title="Numer ~patnika w systemie firmy Sidemka"></a>
                <input type="text" class="text" name="platnik[numer]" id="siodemkaPrzesylkaPlatnikNumer" value="" />
                <a href="{$ADMIN_URL}?action={$action}&mode=kontrahent&search=true" class="search-btn" id="siodemkaPlatnikSzukaj" title="Szukaj patnika">Szukaj</a>
            </div>
        </div>
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPlatnikTelefon">Telefon:</label></div>
            <div class=datavalue>
                <a class="help" title="Telefon kontaktowy dla patnika"></a>
                <input type="text" class="text" name="platnik[telKontakt]" id="siodemkaPrzesylkaPlatnikTelefon" value="" />
            </div>
        </div>
    </td>

    <td width="50%" valign="top" >
      <div class="template0">
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaNumer">Numer odbiorcy:</label></div>
            <div class=datavalue>
                <a class="help" title="Numer odbiorcy w systemie firmy Sidemka uzupeniany po dodaniu nowego kontrahenta do bazy danych"></a>
                <input type="text" class="text" name="odbiorca[numer]" id="siodemkaPrzesylkaOdbiorcaNumer" value="" maxlength="10"/>
                <a href="{$ADMIN_URL}?action={$action}&mode=kontrahent&search=true" class="search-btn" id="siodemkaOdbiorcaSzukaj" title="Szukaj odbiorc">Szukaj</a>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaNrExt">Numer zewntrzny:</label></div>
            <div class=datavalue>
                <a class="help" title="Numer zewntrzny (np. w systemie nadawcy). Pole do dyspozycji klienta (max. 10 znakw alfanumerycznych)"></a>
                <input type="text" class="text" name="odbiorca[nrExt]" id="siodemkaPrzesylkaOdbiorcaNrExt" value="" maxlength="10"/>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaFirma">Firma:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy odbiorca jest firm"></a>
                <input type="checkbox" class="checkbox" name="odbiorca[czyFirma]" id="siodemkaPrzesylkaOdbiorcaFirma" value="1" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaNazwa">Nazwa:</label></div>
            <div class=datavalue>
                <a class="help" title="Nazwa odbiorcy (max. 150 znakw)"></a>
                <input type="text" class="text" name="odbiorca[nazwa]" id="siodemkaPrzesylkaOdbiorcaNazwa" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaNip">NIP:</label></div>
            <div class=datavalue>
                <a class="help" title="Numer NIP odbiorcy (bez kresek) - (max. 10 cyfr)"></a>
                <input type="text" class="text" name="odbiorca[nip]" id="siodemkaPrzesylkaOdbiorcaNip" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaImie">Imi:</label></div>
            <div class=datavalue>
                <a class="help" title="Imi odbiorcy (max. 50 znakw)"></a>
                <input type="text" class="text" name="odbiorca[imie]" id="siodemkaPrzesylkaOdbiorcaImie" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaNazwisko">Nazwisko:</label></div>
            <div class=datavalue>
                <a class="help" title="Nazwisko odbiorcy (max. 100 znakw)"></a>
                <input type="text" class="text" name="odbiorca[nazwisko]" id="siodemkaPrzesylkaOdbiorcaNazwisko" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaKraj">Kraj:</label></div>
            <div class=datavalue>
                <a class="help" title="Kod kraju odbiorcy (zgodnie z ISO 3166-1 alfa-2)"></a>
                <input type="text" class="text" name="odbiorca[kodKraju]" id="siodemkaPrzesylkaOdbiorcaKraj" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaKodPocztowy">Kod pocztowy:</label></div>
            <div class=datavalue>
                <a class="help" title="Kod pocztowy odbiorcy w formacie XX-XXX (gdzie x jest cyfr od 0 do 9)"></a>
                <input type="text" class="text" name="odbiorca[kod]" id="siodemkaPrzesylkaOdbiorcaKodPocztowy" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaMiejscowosc">Miejscowo:</label></div>
            <div class=datavalue>
                <a class="help" title="Miasto odbiorcy (max. 70 znakw)"></a>
                <input type="text" class="text" name="odbiorca[miasto]" id="siodemkaPrzesylkaOdbiorcaMiejscowosc" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel>
                <label for="siodemkaPrzesylkaOdbiorcaUlica">Ulica</label> |
                <label for="siodemkaPrzesylkaOdbiorcaBudynek">Dom</label> |
                <label for="siodemkaPrzesylkaOdbiorcaLokal">Lokal:</label></div>
            <div class=datavalue>
                <a class="help" title="Adres"></a>

                <input type="text " class="text" name="odbiorca[ulica]" id="siodemkaPrzesylkaOdbiorcaUlica" value="" />
                <input type="text " class="text" name="odbiorca[nrDom]" id="siodemkaPrzesylkaOdbiorcaBudynek" value="" size="5" />
                <input type="text " class="text" name="odbiorca[nrLokal]" id="siodemkaPrzesylkaOdbiorcaLokal" value="" size="5" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaTelefon">Telefon:</label></div>
            <div class=datavalue>
                <a class="help" title="Telefon kontaktowy kontrahenta (max. 100 znakw)"></a>
                <input type="text" class="text" name="odbiorca[telKontakt]" id="siodemkaPrzesylkaOdbiorcaTelefon" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOdbiorcaEmail">E-mail:</label></div>
            <div class=datavalue>
                <a class="help" title="Adres email kontrahenta (max. 100 znakw)"></a>
                <input type="text" class="text" name="odbiorca[emailKontakt]" id="siodemkaPrzesylkaOdbiorcaEmail" value="" />
            </div>
        </div>
      </div>

        <div class="template1 message_info">
            Dane odbiorcy przesyki nie s dostepne do edycji przy tworzeniu szablonu przesyki.
        </div>
    </td>
</tr>
</table>

<table width="100%" cellspacing="0" cellpadding="0" border="0">
<tr class="head">
    <td width="50%">Usugi</td>
    <td width="50%">Patno i rodzaj przesyki</td>
</tr>

<tr>
    <td width="50%" valign=top rowspan="13">
        <div class="usulga-opcja rowodd ">
            <input type="checkbox" id="siodemkaPrzesylkaUbezpieczenie" value="1" name="ubezpieczenie">
            <label for="siodemkaPrzesylkaUbezpieczenie">Ubezpieczenie</label> <br />
        </div>

        <div class="usulga-opcja roweven ">
            <input type="checkbox" id="siodemkaPrzesylkaPobranie" value="1" name="pobranie">
            <label for="siodemkaPrzesylkaPobranie">Pobranie</label><br />
        </div>

        <div class="usulga-opcja rowodd ">
            <input type="checkbox" id="siodemkaPrzesylkaUslugazkld" value="1" name="uslugi[zkld]">
            <label for="siodemkaPrzesylkaUslugazkld">Zwrot kopii listu przewozowego</label><br />
        </div>

        <div class="usulga-opcja roweven ">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaZd" value="1" name="uslugi[zd]">
            <label for="siodemkaPrzesylkaUslugaZd">Zwrot dokumentw</label><br />
        </div>

        <div class="usulga-opcja rowodd">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaSkladowanie" value="1" name="skladowanie">
            <label for="siodemkaPrzesylkaUslugaSkladowanie">Skadowanie</label><br />

            <div id="siodemkaPrzesylkaUslugaSkladowanieOpcje" style="">
                <label for="siodemkaPrzesylkaUslugaSkladowanie">Ilo dni</label>
                <input type="text" id="siodemkaPrzesylkaUslugaSkladowanie" value="0" name="uslugi[skladowanie]" >
            </div>
        </div>

        <div class="usulga-opcja roweven">
            <a class="help" title="Telefoniczna informacja o prbie dorczenia przesyki"></a>
            <input type="checkbox" id="siodemkaPrzesylkaUslugaAwizacjaTelefoniczna" value="1" name="uslugi[awizacjaTelefoniczna]">
            <label for="siodemkaPrzesylkaUslugaAwizacjaTelefoniczna">Kontakt telefoniczny</label><br />
        </div>

        <div class="usulga-opcja rowodd">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaPotwierdzenieNadaniaEmail" value="1" name="uslugi[potwNadEmail]">
            <label for="siodemkaPrzesylkaUslugaPotwierdzenieNadaniaEmail">Potwierdzenie nadania e-mail</label><br />
        </div>

        <div class="usulga-opcja roweven">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaPotwierdzenieDostarczenieEmail" value="1" name="uslugi[potwDostEmail]">
            <label for="siodemkaPrzesylkaUslugaPotwierdzenieDostarczenieEmail">Potwierdzenie dostarczenia e-mail</label><br />
        </div>

        <div class="usulga-opcja rowodd">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaPotwierdzenieDostarczenieSMS" value="1" name="uslugi[potwDostSMS]">
            <label for="siodemkaPrzesylkaUslugaPotwierdzenieDostarczenieSMS">Potwierdzenie dostarczenia SMS</label><br />
        </div>

        <div class="usulga-opcja roweven">
            <input type="checkbox" id="siodemkaPrzesylkaZastrzDorNaDzien" value="1" name="zastrzDorNaDzien">
            <label for="siodemkaPrzesylkaZastrzDorNaDzien">Zastrzeenie dorczenia na dzie</label><br />

            <div id="siodemkaPrzesylkaZastrzDorNaDzienOpcje" style="margin-left: 18px;">
                <input type="radio" id="siodemkaPrzesylkaZastrzDorNaDzienSobota" checked="checked" value="S" name="uslugi[zastrzDorNaDzien]" >
                <label for="siodemkaPrzesylkaZastrzDorNaDzienSobota">Sobota</label><br>
                <input type="radio" id="siodemkaPrzesylkaZastrzDorNaDzienNiedziela" value="N" name="uslugi[zastrzDorNaDzien]" >
                <label for="siodemkaPrzesylkaZastrzDorNaDzienNiedziela">Niedziele\wita</label>
            </div>
        </div>

        <div class="usulga-opcja rowodd">
            <input type="checkbox" id="siodemkaPrzesylkaZastrzDorNaGodz" value="1" name="skladowanie">
            <label for="siodemkaPrzesylkaZastrzDorNaGodz">Zastrzeenie dorczenia na godzin</label><br />

            <div id="siodemkaPrzesylkaZastrzDorNaGodzOpcje" style="margin-left: 18px;">
                <label for="siodemkaPrzesylkaUslugaZastrzDorNaGodz">Godzina</label>
                <input type="text" id="siodemkaPrzesylkaUslugaZastrzDorNaGodz" value="0" name="uslugi[zastrzDorNaGodz]" >
            </div>
        </div>

        <div class="usulga-opcja roweven">
            <input type="checkbox" id="siodemkaPrzesylkaBezpiecznaKoperta" value="1" name="nrBezpiecznejKoperty" />
            <label for="siodemkaPrzesylkaBezpiecznaKoperta">Bezpieczna koperta</label><br />
        </div>

        <div class="usulga-opcja roweven padding0" id="siodemkaPrzesylkaBezpiecznaKopertaOpcje">
            <div class=datalabel><label style="padding-left: 30px;" for="siodemkaPrzesylkaUslugaBezpiecznaKoperta">Numer koperty:</label></div>
            <div class=datavalue>
                <input type="text" id="siodemkaPrzesylkaUslugaBezpiecznaKoperta" value="" name="uslugi[nrBezpiecznejKoperty]" />
            </div>
        </div>

        <div class="usulga-opcja rowodd">
            <a class="help" title="Odbir wasny przesyki przez klienta"></a>
            <input type="checkbox" id="siodemkaPrzesylkaUslugaOdbiorWlasny" value="1" name="uslugi[odbWlas]">
            <label for="siodemkaPrzesylkaUslugaOdbiorWlasny">Odbir&nbsp;wasny</label><br />
        </div>

        <div class="usulga-opcja roweven">
            <a class="help" title="Dorczenie palety w strefie B na dzie nastpny"></a>
            <input type="checkbox" id="siodemkaPrzesylkaUslugaPaletaNextDay" value="1" name="uslugi[palNextDay]">
            <label for="siodemkaPrzesylkaUslugaPaletaNextDay">Paleta&nbsp;"Next&nbsp;Day"</label><br />
        </div>

        <div class="usulga-opcja rowodd">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaNadanieOdbiorPKP" value="1" name="uslugi[nadOdbPKP]">
            <label for="siodemkaPrzesylkaUslugaNadanieOdbiorPKP">Nadanie&nbsp;/&nbsp;Odbir&nbsp;PKP</label><br />
        </div>

        <div class="usulga-opcja roweven">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaNadanieOdbiorNadgodziny" value="1" name="uslugi[odbNadgodziny]">
            <label for="siodemkaPrzesylkaUslugaNadanieOdbiorNadgodziny">Odbir&nbsp;-&nbsp;nadgodziny</label><br />
        </div>

        <div class="usulga-opcja rowodd">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaOsobaFizyczna" value="1" name="uslugi[osobaFiz]">
            <label for="siodemkaPrzesylkaUslugaOsobaFizyczna">Dorczenie&nbsp;Osoba&nbsp;fizyczna</label><br />
        </div>

        <div class="usulga-opcja roweven">
            <input type="checkbox" id="siodemkaPrzesylkaUslugaMarket" value="1" name="uslugi[market]">
            <label for="siodemkaPrzesylkaUslugaMarket">Dorczenie&nbsp;Market</label><br />
        </div>

        <div class="usulga-opcja rowodd">
            <a class="help" rel="siodemkaPrzesylkaOpcjaPobranie0Hint"></a>
            <input type="checkbox" id="siodemkaPrzesylkaOpcjaPobranie0" value="1" name="opcje[pobranie0]">
            <label for="siodemkaPrzesylkaOpcjaPobranie0">Bez automatycznego wykrywania pobrania dla dokumentu na podstawie sposobu patnoci</label><br />

            <div id="siodemkaPrzesylkaOpcjaPobranie0Hint" class="hint">
                Jeli ta opcja jest zaznaczona przy tworzeniu przesyki usuga pobrania nie bdzie ustawiana
                w przesyce na podstawie sposobu patnoci dokumentu. Jeli w nazwie sposobu patnoci
                wystpuje sowo pobranie lub sposb patnoci patno "za pobraniem" skonfigurowany w e-commerce
                wwczas w przesyce zostanie ustawiona usuga pobrania na kwot rwn wartoci
                dokumentu.
            </div>
        </div>

        <div class="usulga-opcja roweven">
            <a class="help" rel="siodemkaPrzesylkaOpcjaUbezpieczWartoscDokumentuHint"></a>
            <input type="checkbox" id="siodemkaPrzesylkaOpcjaUbezpieczWartoscDokumentu" value="1" name="opcje[ubezpieczWartoscDokumentu]">
            <label for="siodemkaPrzesylkaOpcjaUbezpieczWartoscDokumentu">Kwot ubezpieczenia ogranicz do wartoci dokumentu</label><br />

            <div id="siodemkaPrzesylkaOpcjaUbezpieczWartoscDokumentuHint" class="hint">
                Jeli ta opcja jest zaznaczona kwota ubezpieczenia jest ograniczana do wartoci dokumentu. W przeciwnym
                wypadku jest ustalana kwota ubezpieczenia wpisana w szablonie przesyki.
            </div>
        </div>
    </td>

    <td width="50%" valign="top">
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaRodzaj">Rodzaj przesyki:</label></div>
            <div class=datavalue>
                <a class="help" title="Nazwisko osoby nadajcej przesyk (max. 100 znakw)"></a>

                <select name="rodzajPrzesylki" id="siodemkaPrzesylkaRodzaj">
                    <option value="">Wybierz</option>
                    {html_options options=$siodemka.rodzajePrzesylek selected=""}
                </select>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaFormaPlatnosci">Forma patnoci:</label></div>
            <div class=datavalue>
                <a class="help" title="Nazwisko osoby nadajcej przesyk (max. 100 znakw)"></a>

                <select name="formaPlatnosci" id="siodemkaPrzesylkaFormaPlatnosci">
                    <option value="">Wybierz</option>
                    {html_options options=$siodemka.formyPlatnosci selected=""}
                </select>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPlaci">Patnik:</label></div>
            <div class=datavalue>
                <a class="help" title="Kto paci za usug. Moliwe wartoci: nadawca, odbiorca lub patnik"></a>

                <select name="placi" id="siodemkaPrzesylkaPlaci">
                    <option value="">Wybierz</option>
                    {html_options options=$siodemka.przesylkaPlatnicy selected=""}
                </select>
            </div>
        </div>

    </td>
</tr>

<tr class="head">
  <td width="50%">Potwierdzenie nadania</td>
</tr>

<tr>
    <td width="50%" valign="top">
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPotwierdzenieData">Data nadania:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>
                <input type="text" class="text" name="potwierdzenieNadania[dataNadania]" id="siodemkaPrzesylkaPotwierdzenieData" value="" readonly="readonly"/>
            </div>
        </div>
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPotwierdzenieNumerKuriera">Numer kuriera:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>
                <input type="text" class="text" name="potwierdzenieNadania[numerKuriera]" id="siodemkaPrzesylkaPotwierdzenieNumerKuriera" value="" />
            </div>
        </div>
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPotwierdzeniePodpis">Podpis:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>
                <input type="text" class="text" name="potwierdzenieNadania[podpisNadawcy]" id="siodemkaPrzesylkaPotwierdzeniePodpis" value="" />
            </div>
        </div>
    </td>
</tr>

<tr class="head">
    <td width="50%" class="head">Ubezpieczenie</td>
</tr>

<tr>
    <td width="50%" valign="top">
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaUbezpieczenieKwota">Kwota ubezpieczenia:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>
                <input type="text" class="text" name="uslugi[ubezpieczenie][kwotaUbezpieczenia]" id="siodemkaPrzesylkaUbezpieczenieKwota" value="" />
            </div>
        </div>
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaUbezpieczenieUwagi">Uwagi:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>
                <textarea class="text" name="uslugi[ubezpieczenie][opisZawartosci]" cols="40" rows="5" id="siodemkaPrzesylkaUbezpieczenieUwagi" ></textarea>
            </div>
        </div>
    </td>
</tr>

<tr class="head">
    <td width="50%">Pobranie</td>
</tr>

<tr>
    <td width="50%" valign="top">
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPobranieKwota">Kwota pobrania:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>
                <input type="text" class="text" name="uslugi[pobranie][kwotaPobrania]" id="siodemkaPrzesylkaPobranieKwota" value="" />
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPobranieForma">Forma pobrania:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>


                <select name="uslugi[pobranie][formaPobrania]" id="siodemkaPrzesylkaPobranieForma">
                    <option value="">Wybierz</option>
                    {html_options options=$siodemka.formyPobrania selected=""}
                </select>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaPobranieKonto">Numer konta:</label></div>
            <div class=datavalue>
                <a class="help" title="Checkbox czy klient jest firm"></a>
                <input type="text" class="text" name="uslugi[pobranie][nrKonta]" id="siodemkaPrzesylkaPobranieKonto" value="" />
            </div>
        </div>
    </td>
</tr>

<tr class="head">
    <td width="50%">Dokument</td>
</tr>

<tr>
    <td width="50%" valign="top">
        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOpcjeZamowienieStatus">Status:</label></div>
            <div class=datavalue>
                <a class="help" title="Po wygenerowaniu przesyki ustaw status zamwienia na"></a>

                <select name="opcje[zk_status]" id="siodemkaPrzesylkaOpcjeZamowienieStatus">
                    <option value="">Wybierz</option>
                    {html_options options=$zk_statusy selected=""}
                </select>
            </div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOpcjeDocSygnatura">Wstaw numer przesyki do sygnatury dokumetu:</label></div>
            <div class=datavalue style="padding-bottom: 20px"><input type="checkbox" class="checkbox" name="opcje[doc_sygnatura]" value="1" id="siodemkaPrzesylkaOpcjeDocSygnatura" /></div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOpcjeZkSygnatura">Wstaw numer przesyki do sygnatury zamwienia:</label></div>
            <div class=datavalue style="padding-bottom: 20px"><input type="checkbox" class="checkbox" name="opcje[zk_sygnatura]" value="1" id="siodemkaPrzesylkaOpcjeZkSygnatura" /></div>
        </div>

        <div class="even padding0">
            <div class=datalabel><label for="siodemkaPrzesylkaOpcjeSpSygnatura">Wstaw numer przesyki do sygnatury paragonu/faktury:</label></div>
            <div class=datavalue style="padding-bottom: 20px"><input type="checkbox" class="checkbox" name="opcje[sp_sygnatura]" value="1" id="siodemkaPrzesylkaOpcjeSpSygnatura" /></div>
        </div>
    </td>
</tr>

<tr class="head">
    <td width="50%"><label for="siodemkaPrzesylkaUwagi">Uwagi</label></td>
</tr>

<tr>
    <td width="50%" valign="top">
        <textarea cols="70" rows="5" type="text" class="text" name="uwagi" id="siodemkaPrzesylkaUwagi" ></textarea>
    </td>
</tr>
</table>

<div id="siodemkaPrzesylkaZamowienia" class="zamowienia"></div>
<div class="clear">&nbsp;</div>

<div>
    <div class="head">Paczki</div>

    <table id="siodemkaPrzesylkaPaczki" border="0" cellpadding="0" cellspacing="0" width="100%">
        <tr class="head">
            <th>Lp.</th>
            <th>Typ</th>
            <th>Waga</th>
            <th>Dugo</th>
            <th>Wysoko</th>
            <th>Szeroko</th>
            <th>Akcje</th>
        </tr>

        <tr class="template">
            <th>%paczka.lp%</th>
            <th>%paczka.waga%</th>
            <th>%paczka.dlugosc%</th>
            <th>%paczka.wysokosc%</th>
            <th>%paczka.szerokosc%</th>
            <th><a href="#" class="edit-btn"></a><a href="#" class="del-btn"></a></th>
        </tr>
    </table>

    <div id="siodemkaPrzesylkaPaczkiInputs" style="display: none"></div>
</div>

</div>

<input type="submit" value="submit" />
</form>
</div>
