<div id="inpostPickupDialog" style="display: none;">
<form action="{$ADMIN_URL}" method="POST" name='inpostPickupForm'>
<input type="hidden" name="action" value="{$action}" />
<input type="hidden" name="mode" value="pickup" />
<input type="hidden" name="call" value="true" />

<div class="data">
    <div class="even padding0">
        <div class=datalabel><label for="InpostPickupLocationName">Nazwa miejsca odbioru paczek:</label></div>
        <div class=datavalue>
            <a class="help" title="Nazwa nadwcy przesyki (max. 100 znakw)"></a>
            <input type="text" class="text required" name="PickupLocation[Name]" id="InpostPickupLocationName" value="" maxlength="100" size=38 />
        </div>
    </div>

    <div class="even padding0">
        <div class=datalabel><label for="InpostPickupLocationPostCode">Kod pocztowy:</label></div>
        <div class=datavalue>
            <a class="help" title="Kod pocztowy nadawcy w formacie XX-XXX (gdzie x jest cyfr od 0 do 9)"></a>
            <input type="text" class="text required postcode" name="PickupLocation[PostCode]" size=10 id="InpostPickupLocationPostCode" value="" />
        </div>
    </div>

    <div class="even padding0">
        <div class=datalabel><label for="InpostPickupLocationCity">Miejscowo odbioru paczek:</label></div>
        <div class=datavalue>
            <a class="help" title="Miasto nadawcy (max. 70 znakw)"></a>
            <input type="text" class="text required" name="PickupLocation[City]" id="InpostPickupLocationCity" value="" />
        </div>
    </div>

    <div class="even padding0">
        <div class=datalabel><label for="InpostPickupLocationKraj">Kraj:</label></div>
        <div class=datavalue>
            <a class="help" title="Kod kraju nadawcy (zgodnie z ISO 3166-1 alfa-2)"></a>
            <input type="text" class="text required country-code" name="PickupLocation[CountryCode]" size=3 id="InpostPickupLocationCountryCode" value="" />

            <label for="InpostPickupLocationCountryCode" class="error" generated="true"></label>
        </div>
    </div>

    <div class="even padding0">
        <div class=datalabel>
            <label for="InpostPickupLocationAddress">Adres odbioru paczek:</label>
        </div>
        <div class=datavalue>
            <a class="help" title="Ulica, nr domu i lokalu nadawct przesyki"></a>

            <input type="text" class="text required" name="PickupLocation[Address]" id="InpostPickupLocationAddress" value="" />
        </div>
    </div>

    <div class="even padding0">
        <div class=datalabel><label for="InpostPickupLocationPerson">Imi i nazwisko:</label></div>
        <div class=datavalue>
            <a class="help" title="Imi i nazwisko osoby nadajcej przesyk (max. 100 znakw)"></a>
            <input type="text" class="text required" name="PickupLocation[Person]" id="InpostPickupLocationPerson" value="" maxlength="100" />
        </div>
    </div>

    <div class="even padding0">
        <div class=datalabel><label for="InpostPickupLocationContact">Telefon:</label></div>
        <div class=datavalue>
            <a class="help" title="Telefon kontaktowy osoby nadajcej przesyk (max. 50 znakw)"></a>
            <input type="text" class="text" name="PickupLocation[Contact]" id="InpostPickupLocationContact" value="" maxlength="50"/>
        </div>
    </div>

    <div class="even padding0">
        <div class=datalabel><label for="InpostPickupLocationEmail">E-mail:</label></div>
        <div class=datavalue>
            <a class="help" title="E-mail osoby nadajcej przesyk (max. 80 znakw)"></a>
            <input type="text" class="text email" name="PickupLocation[Email]" id="InpostPickupLocationEmail" value="" size=30 maxlength="80"/>
        </div>
    </div>

    <div class="even padding0">
      <div class=datalabel><label for="inpostPickupReadyDate">Data odebrania:</label></div>
      <div class=datavalue>
          <a onclick="view('inpostPickupReadyDateHint');" class=help></a>

          <input type="text" class="text clearable required" name="ReadyDate" id="inpostPickupReadyDate" value="" maxlength="16" />

          <div id="inpostPickupReadyDateHint" class="hint">
              Data odebrania
          </div>
      </div>
    </div>

    <div class="even padding0">
      <div class=datalabel><label for="inpostPickupTotalQuantity">czna ilo paczek: </label>:</div>
      <div class=datavalue>
          <a onclick="view('inpostPickupTotalQuantityHint');" class=help></a>

          <input type="text" class="text clearable required" name="TotalQuantity" id="inpostPickupTotalQuantity" value="" maxlength="16" />

          <div id="inpostPickupTotalQuantityHint" class="hint">
              Data odebrania
          </div>
      </div>
    </div>

    <div class="even padding0">
      <div class=datalabel><label for="inpostPickupTotalWeight">czna waga paczek:</label></div>
      <div class=datavalue>
          <a onclick="view('inpostPickupTotalWeightHint');" class=help></a>

          <input type="text" class="text clearable required" name="TotalWeight" id="inpostPickupTotalWeight" value="" maxlength="16" />

          <div id="inpostPickupTotalWeightHint" class="hint">
              Data odebrania
          </div>
      </div>
    </div>



    <div class="odd dokumenty"></div>

    <div class="clear">&nbsp;</div>
</div>

<input type="submit" value="submit" />
</form>
</div>
