<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


function smarty_function_zmien_platnosc_info($params, &$smarty){
    //pobieram z szablonu referencje do obiektu zamwienia
    $zk = &$smarty->get_template_vars('zamowienie');

    //pobieram informacje o opisie patnoci
    $platnosc_info = '';
    if( !empty($zk->PLATNOSC_INFO ) ){
        $platnosc_info = $zk->PLATNOSC_INFO;
    }else if( !empty($zk->platnosc_info ) ){
        $platnosc_info = $zk->platnosc_info;
    }else{
        $platnosc_info = $smarty->get_template_vars('platnosc_info');
    }
    
    if( !empty($platnosc_info) ){
        //zmieniam tylko w wypadku kont b2b
        //$zamien = true; //jesli chcemy
        $zamien = (!empty($_SESSION['osoba']) && isset($_SESSION['osoba']->TYP) && ($_SESSION['osoba']->TYP == KONTO_B2B) );

        //jesli trzeba zamieni i w informacji o patnoci jest numer zamiwneia to zwracam now informacj o patnoci
        if( $zamien && strpos( $platnosc_info, $zk->NUMER) ){
              return '
              Zamwienie zostao przekazane do realizacji, jego numer to: '.$zk->NUMER.'
              <p>Informujemy, i naley dokona wpaty rodkw w wyznaczonym terminie na kwot '.currency_format($zk->WAL_WARTOSC_BRUTTO).' '.$zk->KOD_WALUTY.' na konto:</p>'
              .$zk->BANK_NAZWA.',<br>' // nazwa banku
              .$zk->NUMER_KONTA.'.<br>' // numer konta
              .FIRMA_SHORT_NAME.',<br>' //nazwa firmy pobrana z ustawi e-commerce, Admin -> UStawienia -> Ustawienia Firmy -> Nazwa Firmy
              .FIRMA_ADDRESS.', '.FIRMA_ZIPCODE.' '.FIRMA_PLACE.'<br>
              W opisie przelewu prosimy wpisa numer zamwienia: ' . $zk->NUMER . '</p>';
        }

        return $params['platnosc_info'];
    }
}



?>
